#include "stm32f10x.h"
#include "main.h"
#include <stdio.h>
#include "app.h"

/*
PWM
UPԴصַlankexi.cn
*/

#define PWM_OUT_UFFER_SPEED				10		//PWMֵӼٶ

unsigned int pwm_out_uffer;		//PWM
unsigned int pwm_out_uffer2;	//PWM
unsigned int uart_delay;		//ڴӡӳ


void pwm_out(unsigned int pwm_out_value)
{
	pwm_out_uffer2 ++;
	if(pwm_out_uffer2 > PWM_OUT_UFFER_SPEED)
	{
		if(pwm_out_value != 0){pwm_out_value ++;}
		if(pwm_out_value >= 100){pwm_out_value = 100;}
		unsigned int out = pwm_out_value;
		unsigned int pwm_oc_out = TIM1->CCR1;
		if(out > pwm_out_uffer)
		{
			out = pwm_oc_out + 1;
		}
		else if(out < pwm_out_uffer)
		{
			out = pwm_oc_out - 1;
		}
		else
		{
			if(pwm_oc_out > pwm_out_uffer)
			{
				out = pwm_oc_out - 1;
			}
			else if(pwm_oc_out < pwm_out_uffer)
			{
				out = pwm_oc_out + 1;
			}
		}
		pwm_out_uffer = pwm_out_value;
		TIM1->CCR1 = out;
		
		pwm_out_uffer2 = 0;
	}
}

void uart_out(unsigned int out_data)
{
	uart_delay ++;
	if(uart_delay>195)
	{
		uart_tx(out_data);
		uart_delay = 0;
	}
}

void uart_tx(unsigned char TX_Data)
{
	// ȴֱݼĴ
    while (USART_GetFlagStatus(USART2, USART_FLAG_TXE) == RESET);
    // 
    USART_SendData(USART2, TX_Data);
    // ȴֱ
    while (USART_GetFlagStatus(USART2, USART_FLAG_TC) == RESET);
}

void UART_Init (void)
{	
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART2,ENABLE);  //USART2ʱ
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA,ENABLE);   //GPIOAʱ
	//TX IOʼ
    GPIO_InitTypeDef GPIO_InitStructure;
    GPIO_InitStructure.GPIO_Mode=GPIO_Mode_AF_PP; 		 //
    GPIO_InitStructure.GPIO_Pin=GPIO_Pin_2;   			 //USART2ӦTXΪGPIOA2
    GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz; 	 //50MhZ
    GPIO_Init(GPIOA,&GPIO_InitStructure);
	
	//RX
	GPIO_InitStructure.GPIO_Mode=GPIO_Mode_IPU;  		//
    GPIO_InitStructure.GPIO_Pin=GPIO_Pin_3;
    GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;  	//50MhZ
    GPIO_Init(GPIOA,&GPIO_InitStructure);
	
	//ڳʼ
	USART_InitTypeDef USART_InitStruct;
	USART_StructInit(&USART_InitStruct);  					//ʼĬֵ
	USART_InitStruct.USART_BaudRate=115200;
	USART_InitStruct.USART_HardwareFlowControl=USART_HardwareFlowControl_None;   //ʹӲ
	USART_InitStruct.USART_Mode=USART_Mode_Tx;   			//ֻTX
	USART_InitStruct.USART_Parity=USART_Parity_No;   		//ѡУ
	USART_InitStruct.USART_StopBits=USART_StopBits_1;  		//ֹͣλ1λ
	USART_InitStruct.USART_WordLength=USART_WordLength_8b;	//λ8λ
	USART_Init(USART2,&USART_InitStruct);
	//ʹ
	USART_Cmd(USART2,ENABLE);
}

//PWM GPIOʼ
void PWM_GPIO_Configuration(void)
{
	//GPIOAʱ
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA,ENABLE);
	
	GPIO_InitTypeDef GPIO_InitStructure;
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_8;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOA,&GPIO_InitStructure);
}

//ƿضʱ
void TIM1_Configuration(void) {
	// ʹܶʱ1ʱ
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_TIM1, ENABLE);

    TIM_TimeBaseInitTypeDef PWM_TIM_TimeBaseStructure;
    // öʱ1
    PWM_TIM_TimeBaseStructure.TIM_Period = 100 - 1; 				//ʱʱ
    PWM_TIM_TimeBaseStructure.TIM_Prescaler = 21 - 1;  				//ԤƵ
    PWM_TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;		//Ƶ
	PWM_TIM_TimeBaseStructure.TIM_RepetitionCounter = 0;			//ظ
    PWM_TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;	//ϼ
    // ʼʱ1
    TIM_TimeBaseInit(TIM1, &PWM_TIM_TimeBaseStructure);
	
	//Ƚϳʼ
	TIM_OCInitTypeDef TIM_OCInitStructure;
	TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM1;				//ȽģʽѡPWMģʽ1
	TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_High;		//ԣѡΪ
	TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;	//ʹ
	TIM_OCInitStructure.TIM_Pulse = 1;								//ʼCCRֵ
	TIM_OC1Init(TIM1, &TIM_OCInitStructure);						//TIM1Ƚͨ1
	TIM_OC1PreloadConfig(TIM1, TIM_OCPreload_Enable);				//Ԥװ
	
    // ʱ1
    TIM_Cmd(TIM1, ENABLE);
	TIM_CtrlPWMOutputs(TIM1, ENABLE);
}
