#ifndef __WS2812_H__
#define __WS2812_H__


void WS2812_Init(void);					//WS2812
void WS2812_Send_Data(void);			//
void WS2812_Send_Data_Bit(void);		//λ
void WS2812_GPIO_Configuration(void);	//ws2812GPIO
void TIM2_Configuration(void);			//ws2812ʱ
void LED_DMA_Configuration(void);		//ws2812 DMA
void WS2812_Send_Set(void);				//

#define WS2812_LED_NUM				21	//
#define WS2812_BIT_DATA0			22	//λ0
#define WS2812_BIT_DATA1			44	//λ1

typedef enum {
    WS2812_IDLE = 0,   // WS2812״̬
    WS2812_SET = 1,    // WS2812״̬
    WS2812_SEND = 2    // WS2812״̬
} WS2812_State;
extern WS2812_State WS2812_Send_State;				//״̬
extern unsigned char WS2812_Data[WS2812_LED_NUM];	//WS2812

#endif	
