#include "stm32f10x.h"
#include "main.h"
#include "digital_tube.h"
/*
λ빲
UPԴصַlankexi.cn
*/

#define DIGIT_REFRESH_SPEED 50				//ˢٶ

unsigned char digits[2] = {0, 0}; 			//Ҫʾ2
unsigned char Current_Select_Digit = 0;		//ǰˢµλ
unsigned int Digit_speed;					//ˢٶȼƴ

//
void DIGIT_Init(void)
{
	DIGIT_GPIO_Configuration();
}

//̬ܶѭˢ
void DIGIT_Refresh(void)
{
	if(Digit_speed > DIGIT_REFRESH_SPEED)
	{
		SelectDigit(Current_Select_Digit);			//ѡλ
		DisplayDigit(digits[Current_Select_Digit]);		//ѡ
		if (Current_Select_Digit){Current_Select_Digit = 0;}
		else {Current_Select_Digit = 1;}
		Digit_speed = 0;
	}
	Digit_speed ++;
}

//GPIO
void DIGIT_GPIO_Configuration(void) {
    // ʹGPIOB ʱ
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);

	// GPIO
    GPIO_InitTypeDef GPIO_InitStructure;
    GPIO_InitStructure.GPIO_Pin =  GPIO_Pin_6 | GPIO_Pin_7 | GPIO_Pin_8 | GPIO_Pin_9 | GPIO_Pin_10 | GPIO_Pin_11 | GPIO_Pin_12 | GPIO_Pin_13 | GPIO_Pin_14 | GPIO_Pin_15;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_Init(GPIOB, &GPIO_InitStructure);
}

//ѡ
void DisplayDigit(uint8_t digit) {
    unsigned short  digitCode = 0;
    
    switch (digit) {
        case 0: digitCode = DIGIT_0; break;
        case 1: digitCode = DIGIT_1; break;
        case 2: digitCode = DIGIT_2; break;
        case 3: digitCode = DIGIT_3; break;
        case 4: digitCode = DIGIT_4; break;
        case 5: digitCode = DIGIT_5; break;
        case 6: digitCode = DIGIT_6; break;
        case 7: digitCode = DIGIT_7; break;
        case 8: digitCode = DIGIT_8; break;
        case 9: digitCode = DIGIT_9; break;
		case 10: digitCode = DIGIT_10; break;	//100
		case 11: digitCode = DIGIT_11; break;	//ر
        default: break;
    }
    
    // ܱλ PB8-PB15 Ӧλ
    digitCode <<= 8;
    // ֻ GPIOB ĸ 8 λ (PB8-PB15) 8 λ (PB0-PB7)
    GPIOB->ODR = (GPIOB->ODR & 0x00FF) | (~digitCode & 0xFF00);
}

//ѡλ
void SelectDigit(uint8_t position) {
    //  PB6-PB7 λѡ״̬
	GPIOB->ODR |= 0xCD;

    // öӦλѡ
    switch (position) {
        case 0: GPIOB->ODR &= ~(0x40); break; // ѡ1λ
        case 1: GPIOB->ODR &= ~(0x80); break; // ѡ2λ
        default: break;
    }
}

//ֲֳɸλϵֵ
void DisplayNumber(uint16_t number) {
	if(number > 199)			//رʾ/ʾ100
	{
		digits[0] = 11;
		digits[1] = 11;
	}
	else if(number > 99)		//ʾ100
	{
		digits[0] = 10;
		digits[1] = 10;
	}
	else
	{
		digits[0] = number / 10;
		digits[1] = number % 10;
	}
}
