#include "stm32f10x.h"
#include <math.h>
#include "main.h"
#include "gradient_led.h"
#include "ws2812.h"
/*
ʵWS2811ɫƴ䡢ƶм
UPԴصַlankexi.cn
*/
#define LED_LOW_BRIGHT		8		//ֵ
#define LED_HIGH_BRIGHT		120		//ֵ
unsigned int ws2812_dynamic_led, dynamic_led_pace, dynamic_led_direction, dynamic_led_ago;	//̬ݴֵ

void update_gradient_led(unsigned int number)
{
	int i;
	unsigned int LED_Proportion_value = MAX_BRIGHT_VALUE / WS2812_LED_NUM;					// LEDӦıֵ
	unsigned int High_bright_num = number / LED_Proportion_value;							// ȫ
	unsigned int Middle_bright_value = (number % LED_Proportion_value)*(LED_HIGH_BRIGHT-LED_LOW_BRIGHT)/(LED_Proportion_value)+LED_LOW_BRIGHT;	//ɵֵ
	for(i=0; i<High_bright_num; i++)
	{
		WS2812_Data[i] = LED_HIGH_BRIGHT;
	}
	WS2812_Data[i] = Middle_bright_value;
	i ++;
	if(WS2812_Send_State == WS2812_SEND)
	{
		while(i<WS2812_LED_NUM)
		{
			WS2812_Data[i] = LED_LOW_BRIGHT;
			i++;
		}
	}
	dynamic_led_ago = 1;
}

void update_about_dynamic_led(void)
{
	dynamic_led_pace ++;
	if(dynamic_led_pace > 1)
	{
		if(ws2812_dynamic_led < 256*2){ws2812_dynamic_led = 256*2;}
		if(dynamic_led_direction == 0)
		{
			ws2812_dynamic_led ++;
			if(ws2812_dynamic_led >= ((WS2812_LED_NUM-3) * 256))
			{
				dynamic_led_direction = 1;
			}
		}
		else
		{
			ws2812_dynamic_led --;
			if(ws2812_dynamic_led <= 256*2)
			{
				dynamic_led_direction = 0;
			}
		}
		dynamic_led_pace = 0;
	}
	if(WS2812_Send_State == WS2812_SEND)
	{
		for(int i=0; i<WS2812_LED_NUM; i++)
		{
			if(i == (ws2812_dynamic_led / 256))
			{
				WS2812_Data[i+1] = (ws2812_dynamic_led % 256) * LED_HIGH_BRIGHT / 256;
				WS2812_Data[i] = (256 - ws2812_dynamic_led % 256) * LED_HIGH_BRIGHT / 256;
				i ++;
			}
			else{WS2812_Data[i] = 0;}
		}
	}
	dynamic_led_ago = 2;
}

void update_middle_dynamic_led(void)
{
	if(dynamic_led_ago != 3){
		ws2812_dynamic_led = LED_HIGH_BRIGHT/4;
		dynamic_led_direction = 1;
	}
	dynamic_led_pace ++;
	if(dynamic_led_pace > 1200)
	{
		if(dynamic_led_direction == 0)
		{
			ws2812_dynamic_led ++;
			if(ws2812_dynamic_led >= LED_HIGH_BRIGHT/2)
			{
				dynamic_led_direction = 1;
			}
		}
		else
		{
			ws2812_dynamic_led --;
			if(ws2812_dynamic_led <= 5)
			{
				dynamic_led_direction = 0;
			}
		}
		dynamic_led_pace = 0;
	}
	if(ws2812_dynamic_led > 255){ws2812_dynamic_led = 255;}
	if(WS2812_Send_State == WS2812_SEND)
	{
		for(int i=0; i<WS2812_LED_NUM; i++)
		{
			if(i == 10){WS2812_Data[i] = ws2812_dynamic_led;}
			else{WS2812_Data[i] = 0;}
		}
	}
	dynamic_led_ago = 3;
}
