#include "stm32f10x.h"
#include "main.h"
#include "touch.h"
#include "ws2812.h"
#include "gradient_led.h"
#include "app.h"
#include "digital_tube.h"
#include "app.h"

/*顢⡢λ
 1.ֱӵ򻬶鼴ɸֵ
	 2.15%µĻָٰȥɹر
	 3.һλʮϿֶԶ
	ͨҪͨʱԶ⡢Ҳ֪ӦҪʮ롢ֻл仯ϴҪϲҪֶ

ʾ 1.
		ʾӦİٷֱ
		ررʾ
		⻷ʾ00
	 2.WS2811ɫƴ
		ݵ򻬶λñ仯
		رмһƺ
		⻷ƶ
	 
 1.HEXʽÿ10ms0-100ֵ0Ϊ⻷رʱΪֹͣ
	 2.PWMռձ2-100	رʱֹͣ

	 UPԴصַlankexi.cn
*/

int main(void)
{
	SetSysClockTo64();		//ʱ
	UART_Init();			//ô
	DIGIT_Init();			//
	TOUCH_Init();			//ô
	WS2812_Init();			//WS2812
	
	//Ӧ
	PWM_GPIO_Configuration();		//PWMGPIO
	TIM1_Configuration();			//PWM
	
	unsigned int Display_value = 10;
	unsigned int Display_value_10 = 1;

	while (1)
	{
		//ֵ
		if(touch_vref_confirm == 0){Display_value = TOUCH_slider(MAX_BRIGHT_VALUE);}
		if(Display_value < 10){Display_value = 10;}
		Display_value_10 = Display_value / 10;
		//´
		//PWM
		//֣ˢڴõĶʱͬٵˢ£
		//½LEDֵˢڴõĶʱͬٵˢ£
		if(touch_vref_confirm != 0)				//⻷
		{
			update_about_dynamic_led();
			DisplayNumber(0);
			uart_out(0);
		}	
		else if(function_out == 0)				//ر
		{
			update_middle_dynamic_led();
			pwm_out(0);
			DisplayNumber(200);
		}	
		else									//
		{
			update_gradient_led(Display_value);
			pwm_out(Display_value_10);
			DisplayNumber(Display_value_10);
			uart_out(Display_value_10);
		}
		
		delay_us(10);
	}
}

void SetSysClockTo64(void)
{
    // 1.  HSI
    RCC_HSICmd(ENABLE);

    // 2. ȴ HSI 
    while (RCC_GetFlagStatus(RCC_FLAG_HSIRDY) == RESET);

    // 3.  FLASH Ԥȡ͵ȴ״̬
    FLASH->ACR |= FLASH_ACR_PRFTBE;  // Ԥȡ
    FLASH->ACR &= ~FLASH_ACR_LATENCY;
    FLASH->ACR |= FLASH_ACR_LATENCY_2;  // 2ȴ״̬

    // 4.  AHB, APB1  APB2 Ƶ
    RCC_HCLKConfig(RCC_SYSCLK_Div1); // AHB ʱ (HCLK) = SYSCLK
    RCC_PCLK1Config(RCC_HCLK_Div2); // APB1 ʱ (PCLK1) = HCLK / 2
    RCC_PCLK2Config(RCC_HCLK_Div1); // APB2 ʱ (PCLK2) = HCLK

    // 5.  PLL
    RCC_PLLConfig(RCC_PLLSource_HSI_Div2, RCC_PLLMul_16); // PLL ʱԴѡ HSI/2, ƵϵΪ 16

    // 6.  PLL
    RCC_PLLCmd(ENABLE);

    // 7. ȴ PLL 
    while (RCC_GetFlagStatus(RCC_FLAG_PLLRDY) == RESET);

    // 8. ѡ PLL ΪϵͳʱԴ
    RCC_SYSCLKConfig(RCC_SYSCLKSource_PLLCLK);

    // 9. ȴ PLL ϵͳʱԴ
    while (RCC_GetSYSCLKSource() != 0x08);
}

//ʱus
void delay_us(unsigned int delayus)
{
	unsigned int i, j;
	for(i=0;i<delayus;i++)
	{
		for(j=0;j<8;j++);//Լ1us
	}
}
//ʱms
void delay_ms(unsigned int delayms)
{
	unsigned int i, j;
	for(i=0;i<delayms;i++)
	{
		for(j=0;j<8300;j++);//Լ1ms
	}
}
