#include "stm32f10x.h"
#include "main.h"
#include "touch.h"
#include <stdlib.h>
#include "ws2812.h"
#include "digital_tube.h"
/*
顢⡢λ
UPԴصַlankexi.cn
*/

#define ADC_FILTERING_SIZE				1500		//˲ֵֵ˲Ч/Ӧ
#define TOUCH_MODEL_MAX_VREF			3700		//ǰģ͵׼ֵÿųѲʱŵֵΪ׼ֵ
#define TOUCH_MODEL_MIN_VREF			1800		//ǰģ͵С׼ֵÿųѲʱŵֵΪ׼ֵ
#define TOUCH_VREF_ADJUST_SPEED			20			//׼ֵԶٶԽСԽ
#define TOUCH_PRESS						110			//Ӧֵ
#define TOUCH_INSTRUCT_SPEED			28000		//ⴥָʶٶ/ʱ
#define VREF_CONFIRM_NUMBER				17			//׼ѹȷϴ

#define TOUCH_CACHE_SIZE				4			//С

unsigned short touch_adc_data[4];					//ADC
unsigned int ADC_Filtering[4];						//˲õʱ
unsigned short touch_sensor_value[4];				//˲Ĳ
unsigned int ADC_Filtering_tally = 0;				//˲Ĳݼ
unsigned short touch_vref_max[4];					//׼ֵֵtouch_vref_max[0]д0
unsigned short touch_vref_min[4];					//׼ֵСֵtouch_vref_max[0]д0
unsigned int touch_vref_speed_tally[4];				//׼ֵٶȼ
unsigned short touch_vref[4];						//΢Ļ׼ֵ
unsigned short touch_vref_confirm = VREF_CONFIRM_NUMBER;//ȷϴʼ׼
unsigned short touch_key_cache[TOUCH_CACHE_SIZE];	//ݻʶ
unsigned int touch_vref_manual_tally;				//׼ֶʶ
unsigned int touch_vref_manual_parameter;			//׼ֶʶ
unsigned short touch_key[4];						//ֵ


unsigned int touch_slider_value = 200;				//ǰĴֵ
unsigned int touch_lock;							//־λ
unsigned int function_out = 0;						//־λ
unsigned int touch_instruct_tim = 0;				//ָȴʱ
unsigned int touch_instruct_tim2 = TOUCH_INSTRUCT_SPEED;//ָȴʱ
unsigned int touch_instruct_state1;					//¼ָʱ״̬

//麯
int TOUCH_slider (unsigned short slider_max)
{
	unsigned int touch_key_trim[4];
	unsigned int touch_slider = 2000;
	//΢ֵ
	touch_key_trim[0] = touch_key[0]*1.3;
	touch_key_trim[1] = touch_key[1]*0.8;
	touch_key_trim[2] = touch_key[2];
	touch_key_trim[3] = touch_key[3]*1.2;
	//
	unsigned int touch_slider1 = touch_key_trim[1]+touch_key_trim[2];	//1ֵ
	unsigned int touch_slider2 = touch_key_trim[1]+touch_key_trim[3];	//2ֵ
	unsigned int touch_slider_whole = touch_key_trim[1] + touch_key_trim[2] + touch_key_trim[3];					//лֵ
	unsigned int touch_all_value = touch_key_trim[0] + touch_key_trim[1] + touch_key_trim[2] + touch_key_trim[3];	//дֵ
	
	if(touch_slider_whole > TOUCH_PRESS)
	{
		if((touch_key_trim[2])>touch_key_trim[3])		//㻬1
		{
			unsigned int touch_slider1_basis = (touch_slider1 / 2.7 - touch_key_trim[3] / (5 + touch_slider2/130))*1.15;
			if(touch_key_trim[2] > touch_slider1_basis){touch_slider = ((float)(touch_key_trim[2] - touch_slider1_basis)/touch_slider1_basis) * slider_max / 2;}
			else{touch_slider = slider_max / 100;}									//ƻ1Сֵ
			if(touch_slider > (slider_max/2)){touch_slider = slider_max / 2;}		//ƻ1ֵ
		}
		else											//㻬2
		{
			unsigned int touch_slider2_basis = (touch_slider2 / 2.7 - touch_key_trim[2] / (5 + touch_slider1/130))*1.15;
			if(touch_key_trim[3] > touch_slider2_basis){touch_slider = slider_max-((float)(touch_key_trim[3]-touch_slider2_basis)/touch_slider2_basis)*slider_max/2;}
			else{touch_slider = slider_max;}										//ƻ2ֵ
			if(touch_slider < (slider_max/2)){touch_slider = slider_max/2;}			//ƻ2Сֵ
		}
		//Ե
		if(touch_key_trim[0] > touch_slider1 && touch_key_trim[0] > touch_slider2){touch_slider = 0;}
		//д΢Ļ׼ֵ
		for(int i=0; i<4; i++){touch_vref_speed_tally[i] = 0;}
	}
	
	//津// еƶһλ
	for (int i = TOUCH_CACHE_SIZE-1; i>0; i--) {
		touch_key_cache[i] = touch_key_cache[i - 1];
	}
	// µݷĵһλ
	if(touch_slider != 2000){touch_key_cache[0] = touch_slider;}
	else{touch_key_cache[0] = 0;}
	
	///ʶ
	if(touch_slider != 0 && touch_slider != 2000)
	{
		//ͻ
		if(touch_key_cache[1] != 0 && (abs(touch_slider - touch_key_cache[1])) > slider_max*0.7)
		{
			touch_slider = 0;
			touch_lock = 1;
		}
		//ͻ
		if((abs(touch_slider - touch_slider_value)) < slider_max*0.1 && (abs(touch_key_cache[1] - touch_slider_value)) < slider_max*0.1){
			touch_lock = 0;
		}
		//رָ
		if(touch_key_cache[1] == 0 && touch_slider != 0 && touch_slider < slider_max*0.15)
		{
			touch_instruct_tim = 1;
			touch_instruct_state1 = touch_all_value;
		}
		//ִйرָӳ٣󴥣
		if(touch_instruct_tim2 >= TOUCH_INSTRUCT_SPEED)
		{
			function_out = 1;
			touch_instruct_tim2 = 0;
		}
		//ô׼ʶ
		if(abs(touch_slider - touch_vref_manual_parameter) < slider_max*0.08)
		{
			if(touch_vref_manual_tally == 0){touch_vref_manual_parameter = touch_slider;}
			touch_vref_manual_tally ++;
			if(touch_vref_manual_tally > TOUCH_INSTRUCT_SPEED*4)
			{
				touch_vref_manual_tally = 0;
				touch_vref_confirm = VREF_CONFIRM_NUMBER;
			}
		}
		else
		{
			touch_vref_manual_parameter = touch_slider;
			touch_vref_manual_tally = 0;
		}
	}
	//ִйرָӳ٣󴥣
	if(touch_instruct_tim2 < TOUCH_INSTRUCT_SPEED){touch_instruct_tim2 ++;}
	//رָʶ
	if(touch_instruct_tim != 0)
	{
		touch_instruct_tim ++;
		if(touch_instruct_tim > TOUCH_INSTRUCT_SPEED){touch_instruct_tim = 0;}
		if(touch_key_cache[1] == 0 && touch_all_value > touch_instruct_state1 * 1.5 && touch_key_trim[0] > touch_key_trim[1] * 1.5)
		{
			function_out = 0;
			touch_instruct_tim = 0;
		}
	}
	
	//
	if(touch_slider == 2000)
	{
		touch_lock = 0;
		touch_slider = 0;
	}
	
	//ȷϴ
	if(touch_slider != 0 && touch_lock == 0){touch_slider_value = touch_slider;}
	return touch_slider_value;
}

//
void TOUCH_Init(void)
{
	TOUCH_DMA_Configuration();		//DMA
	TOUCH_ADC_Configuration();		//ADC
	TOUCH_GPIO_Configuration();		//GPIO
	TIM3_Configuration();			//ʱ
	touch_vref_max[0] = 0;			//ô׼ֵ
}

//ADC
void TOUCH_ADC_Configuration(void) {
	// ʹGPIOʱ
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, ENABLE);
	// ʹADC1ʱ
    RCC_APB2PeriphClockCmd(RCC_APB2Periph_ADC1, ENABLE);
    
	//GPIO
	GPIO_InitTypeDef GPIO_InitStructure;
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4 | GPIO_Pin_5 | GPIO_Pin_6 | GPIO_Pin_7;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AIN;
    GPIO_Init(GPIOA, &GPIO_InitStructure);
	
    // ADC
	ADC_InitTypeDef ADC_InitStructure;
	ADC_InitStructure.ADC_Mode = ADC_Mode_Independent;                 	 // ADCģʽΪģʽ
	ADC_InitStructure.ADC_ScanConvMode = ENABLE;                        // ɨתģʽ
	ADC_InitStructure.ADC_ContinuousConvMode = DISABLE;                  // תģʽ
	ADC_InitStructure.ADC_ExternalTrigConv = ADC_ExternalTrigConv_None;  // ʹⲿת
	ADC_InitStructure.ADC_DataAlign = ADC_DataAlign_Right;               // Ҷ
	ADC_InitStructure.ADC_NbrOfChannel = 4;                              // תͨΪ4
	ADC_Init(ADC1, &ADC_InitStructure);                                  // ʼADC1
	
    //  ADC ͨ
    ADC_RegularChannelConfig(ADC1, ADC_Channel_4, 1, ADC_SampleTime_13Cycles5);
    ADC_RegularChannelConfig(ADC1, ADC_Channel_5, 2, ADC_SampleTime_13Cycles5);
    ADC_RegularChannelConfig(ADC1, ADC_Channel_6, 3, ADC_SampleTime_13Cycles5);
    ADC_RegularChannelConfig(ADC1, ADC_Channel_7, 4, ADC_SampleTime_13Cycles5);
	
	 //  ADC DMA 
    ADC_DMACmd(ADC1, ENABLE);

    // ʹADC1
    ADC_Cmd(ADC1, ENABLE);

    // ADCУ׼
    ADC_ResetCalibration(ADC1);
    while (ADC_GetResetCalibrationStatus(ADC1));
    ADC_StartCalibration(ADC1);
    while (ADC_GetCalibrationStatus(ADC1));
	
	// ADCת
    ADC_SoftwareStartConvCmd(ADC1, ENABLE);
}

//GPIOPWM
void TOUCH_GPIO_Configuration(void)
{
	//GPIOBʱ
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB,ENABLE);
	
	GPIO_InitTypeDef GPIO_InitStructure;
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
	GPIO_Init(GPIOB,&GPIO_InitStructure);
}

void TOUCH_DMA_Configuration(void) {
    //  DMA ʱ
    RCC_AHBPeriphClockCmd(RCC_AHBPeriph_DMA1, ENABLE);

    //  DMA
	DMA_InitTypeDef DMA_InitStructure;
    DMA_InitStructure.DMA_PeripheralBaseAddr = (uint32_t)&ADC1->DR;  	// ַΪ ADC ݼĴ
    DMA_InitStructure.DMA_MemoryBaseAddr = (uint32_t)touch_adc_data; 	// ڴַΪ ADC_Filtering 
    DMA_InitStructure.DMA_DIR = DMA_DIR_PeripheralSRC; 					// ݴ䷽赽ڴ
    DMA_InitStructure.DMA_BufferSize = 4; 								// Сͨ
    DMA_InitStructure.DMA_PeripheralInc = DMA_PeripheralInc_Disable;	// ַ
    DMA_InitStructure.DMA_MemoryInc = DMA_MemoryInc_Enable;  			// ڴַ
    DMA_InitStructure.DMA_PeripheralDataSize = DMA_PeripheralDataSize_HalfWord;  // ݴС֣16 λ
    DMA_InitStructure.DMA_MemoryDataSize = DMA_MemoryDataSize_HalfWord; // ڴݴС֣16 λ
    DMA_InitStructure.DMA_Mode = DMA_Mode_Circular; 					// ѭģʽ
    DMA_InitStructure.DMA_Priority = DMA_Priority_High; 				// ȼ
    DMA_InitStructure.DMA_M2M = DMA_M2M_Disable;  						// ֹڴ浽ڴ洫
    DMA_Init(DMA1_Channel1, &DMA_InitStructure); 						// ʼ DMA ͨ 1

    //  DMA ͨ
    DMA_Cmd(DMA1_Channel1, ENABLE);
}

// ⴥADCŵѹ
void Read_Touch_Sensor(void) {
	// ȴת
	unsigned int e = 0;		//ʱ
    while (!DMA_GetFlagStatus(DMA1_FLAG_TC1) && e<100)
	{
		e++;
	}
	// DMAɱ־
    DMA_ClearFlag(DMA1_FLAG_TC1);
	// ˲
	for (int i = 0; i < 4; i++){ADC_Filtering[i] += touch_adc_data[i];}
	ADC_Filtering_tally ++;
	if(ADC_Filtering_tally > ADC_FILTERING_SIZE)
	{
		for (int i = 0; i < 4; i++)		//˲
		{
			touch_sensor_value[i] = ADC_Filtering[i]/ADC_FILTERING_SIZE;
			ADC_Filtering[i] = 0;
			touch_key[i] = abs(touch_vref[i]-touch_sensor_value[i]);
			//׼ֵ
			if(touch_sensor_value[i] < touch_vref[i]){
				touch_vref_speed_tally[i] --;
				if(abs(touch_vref_speed_tally[i]) > TOUCH_VREF_ADJUST_SPEED)
				{
					if(touch_vref[i] > touch_vref_min[i]){touch_vref[i] --;}
					touch_vref_speed_tally[i] = 0;
				}
				
			}
			else if(touch_sensor_value[i] > touch_vref[i]){
				touch_vref_speed_tally[i] ++;
				if(touch_vref_speed_tally[i] > TOUCH_VREF_ADJUST_SPEED)
				{
					if(touch_vref[i] < touch_vref_max[i]){touch_vref[i] +=2;}
					touch_vref_speed_tally[i] = 0;
				}
			}
		}
		ADC_Filtering_tally = 0;
		if(touch_vref_max[0] == 0)		//дʼ׼ֵ
		{
			for (int i = 0; i < 4; i++)	//дֵ
			{
				touch_vref_max[i] = touch_sensor_value[i]*1.1;	//΢ֵ
				touch_vref_min[i] = touch_sensor_value[i]*0.9;	//΢Сֵ
				if(touch_sensor_value[i] > TOUCH_MODEL_MAX_VREF || touch_sensor_value[i] < TOUCH_MODEL_MIN_VREF){touch_vref_max[0] = 0;}//Ŵ
				touch_vref[i] = touch_sensor_value[i];			//дʼ׼ֵ
			}
		}
		if(touch_vref_confirm > 0)		//ȷϴʼ׼ֵ
		{
			unsigned int touch_key_value = touch_key[0] + touch_key[1] + touch_key[2] + touch_key[3];
			unsigned int touch_key_max_value = 1;
			unsigned int touch_key_min_value = 4095;
			for(int i = 0; i < 4; i++)
			{
				if(touch_sensor_value[i]>touch_key_max_value){touch_key_max_value = touch_sensor_value[i];}
				if(touch_sensor_value[i]<touch_key_min_value){touch_key_min_value = touch_sensor_value[i];}
			}
			if(touch_key_value < TOUCH_PRESS && touch_key_max_value < TOUCH_MODEL_MAX_VREF && touch_key_min_value > TOUCH_MODEL_MIN_VREF)
			{
				touch_vref_confirm--;
			}
			else{
				touch_vref_confirm = VREF_CONFIRM_NUMBER;
				touch_vref_max[0] = 0;
			}
		}
	}
	// ADCת
    ADC_SoftwareStartConvCmd(ADC1, ENABLE);
}

//ʱ
void TIM3_Configuration(void) {
	// ʹܶʱ3ʱ
	RCC_APB1PeriphClockCmd(RCC_APB1Periph_TIM3, ENABLE);
	// ʹ AFIO ʱ
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO, ENABLE);
    //  TIM3_CHΪӳģʽ
    GPIO_PinRemapConfig(GPIO_PartialRemap_TIM3, ENABLE);
	
    TIM_TimeBaseInitTypeDef PWM_TIM_TimeBaseStructure;
    // öʱ3Ϊ1HzƵ
    PWM_TIM_TimeBaseStructure.TIM_Period = 200 - 1; 				//ʱʱ
    PWM_TIM_TimeBaseStructure.TIM_Prescaler = 10 - 1;  				//ԤƵ
    PWM_TIM_TimeBaseStructure.TIM_ClockDivision = TIM_CKD_DIV1;		//Ƶ
	//PWM_TIM_TimeBaseStructure.TIM_RepetitionCounter = 0;		//ظ
    PWM_TIM_TimeBaseStructure.TIM_CounterMode = TIM_CounterMode_Up;		//ϼ
    // ʼʱ3
    TIM_TimeBaseInit(TIM3, &PWM_TIM_TimeBaseStructure);
	
	// ʹܶʱ3ж
    TIM_ITConfig(TIM3, TIM_IT_Update, ENABLE);
	
	NVIC_InitTypeDef NVIC_InitStructure;
	// öʱ3жȼ
    NVIC_InitStructure.NVIC_IRQChannel = TIM3_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);
	
	//Ƚϳʼ
	TIM_OCInitTypeDef TIM_OCInitStructure;
	TIM_OCInitStructure.TIM_OCMode = TIM_OCMode_PWM1;				//ȽģʽѡPWMģʽ1
	TIM_OCInitStructure.TIM_OCPolarity = TIM_OCPolarity_High;		//ԣѡΪ
	TIM_OCInitStructure.TIM_OutputState = TIM_OutputState_Enable;	//ʹ
	TIM_OCInitStructure.TIM_Pulse = 100;							//ʼCCRֵ
	TIM_OC2Init(TIM3, &TIM_OCInitStructure);						//TIM3Ƚͨ2
	TIM_OC2PreloadConfig(TIM3, TIM_OCPreload_Enable);				//Ԥװ

    // ʱ3
    TIM_Cmd(TIM3, ENABLE);
}

//ʱ3жϷ
void TIM3_IRQHandler(void)
{
    if (TIM_GetITStatus(TIM3, TIM_IT_Update) != RESET)
    {
        Read_Touch_Sensor();											//ⴥADCŵѹ
		if (WS2812_Send_State == WS2812_IDLE){WS2812_Send_Data();}		//ˢWS2812
		DIGIT_Refresh();												//ˢ
		// ʱжϱ־λ
        TIM_ClearITPendingBit(TIM3, TIM_IT_Update);
    }
}
